#include <windows.h>
#include <windowsx.h>
#include <stdio.h>
#include "resource.h"
#include "dxfunc.h"


LRESULT CALLBACK WndProc (HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK RenderWndProc (HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK DialogProc (HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);
void InitDialog (HWND hWnd, HINSTANCE hInst);


char szClassName[] = "DirectX Demo";    // Ŭ
char szRenderClassName[] = "Render class";
BOOL		gbActive = TRUE;
HWND        g_hWnd  = NULL;
HWND        ghRenderWnd = NULL;
HINSTANCE   ghInst = NULL;
HWND        ghDlg = NULL;
float		gAspect = 1.0f;

int gRenderScrWidth = 0;
int gRenderScrHeight = 0;
static bool gRotateCamera = false;

extern LRESULT HandleMessages(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

bool GetRotateCamera()
{
	return gRotateCamera;
}

ATOM InitApp (HINSTANCE hInst)
{
	{
		WNDCLASSEX wc;
		wc.cbSize = sizeof(WNDCLASSEX);
		wc.style =  CS_HREDRAW | CS_VREDRAW;
		wc.lpfnWndProc = RenderWndProc;  
		wc.cbClsExtra = 0;
		wc.cbWndExtra = 0;
		wc.hInstance = hInst;
		wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
		wc.hCursor = LoadCursor(NULL, IDC_ARROW);
		wc.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);
		wc.lpszMenuName = NULL;   
		wc.lpszClassName = (LPCSTR) szRenderClassName;
		wc.hIconSm  = NULL;
		RegisterClassEx( &wc );
	}

    WNDCLASSEX wc;
    wc.cbSize = sizeof(WNDCLASSEX);
    wc.style =  CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc = WndProc;  
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hInstance = hInst;
	wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
    wc.hCursor = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH) GetStockObject(BLACK_BRUSH);
    wc.lpszMenuName = "MAINMENU";    
    wc.lpszClassName = (LPCSTR) szClassName;
    wc.hIconSm  = NULL;
    return (RegisterClassEx(&wc));
}

BOOL InitInstance (HINSTANCE hInst, int nCmdShow)
{
    HWND hWnd;

    hWnd = CreateWindow(szClassName,
            szClassName,
            WS_OVERLAPPEDWINDOW & ~WS_THICKFRAME & ~WS_MAXIMIZEBOX,
            CW_USEDEFAULT,    
            CW_USEDEFAULT,    
            XSIZE,    
            YSIZE,    
            NULL, 
            NULL, //޴ ڵ, Ŭ ޴   NULL
            hInst, 
            NULL);
    if (! hWnd)
        return FALSE;

	g_hWnd = hWnd;

    ghRenderWnd = CreateWindow(szRenderClassName, 
			NULL, 
			WS_CHILD | WS_VISIBLE, 
			10,        
			10,        
			100,
			100,
			hWnd,
			NULL,    
			hInst,
			NULL);

    ShowWindow(hWnd, nCmdShow);
    UpdateWindow(hWnd);
    return TRUE;
}


int WINAPI WinMain (HINSTANCE hCurInst, HINSTANCE hPrevInst, LPSTR lpsCmdLine, int nCmdShow)
{
    MSG msg;
    
    ghInst = hCurInst;
    if (! InitApp(hCurInst))
        return -1;

    if (! InitInstance(hCurInst, nCmdShow)) 
        return -1;

	if(InitD3D(g_hWnd)!= S_OK )
		return -1;

	if( !InitShadowRenderTarget())
		return -1;

	// Setup Projection 
	{
		RECT rect;
		GetClientRect(ghRenderWnd, &rect);
		float width = (float)rect.right;
		float height = (float)rect.bottom;
		gAspect = width / height;

		gRenderScrWidth = rect.right;
		gRenderScrHeight = rect.bottom;
	}
	InitSetupCamera(gAspect);

	if(!LoadAsset())
		return -1;

	LoadFont();

	BOOL bGotMsg = FALSE;

	msg.message = WM_NULL;
	PeekMessage( &msg, NULL, 0U, 0U, PM_NOREMOVE );
    while( WM_QUIT != msg.message  )
    {
        // Use PeekMessage() if the app is active, so we can use idle time to
        // render the scene. Else, use GetMessage() to avoid eating CPU time.
        if( gbActive )
            bGotMsg = PeekMessage( &msg, NULL, 0U, 0U, PM_REMOVE );
        else
            bGotMsg = GetMessage( &msg, NULL, 0U, 0U );

        if( bGotMsg )
        {
            // Translate and dispatch the message
            //if( 0 == TranslateAccelerator( g_hWnd, hAccel, &msg ) )
            {
                TranslateMessage( &msg );
                DispatchMessage( &msg );
            }
        }
        else
        {
            // Render a frame during idle time (no messages are waiting)
            if( gbActive )//&& m_bReady )
            {
                if( FAILED( RenderLoop()))
                    SendMessage( g_hWnd, WM_CLOSE, 0, 0 );
            }
        }
    }

/*
    while (GetMessage(&msg, NULL, 0, 0))
	{
		if ((ghDlg== 0) || ! IsDialogMessage(ghDlg, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
    }
*/

	UnregisterClass( szRenderClassName, hCurInst);
	UnregisterClass( szClassName, hCurInst);

    return 0;
}
//------------------------------------------------------------------------------------------
LRESULT CALLBACK RenderWndProc (HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	HandleMessages(hWnd, msg, wParam, lParam);

    switch (msg) 
	{
        case WM_CREATE:
			{
				RECT rc, dlgrc;
				GetWindowRect(g_hWnd, &rc);	
				int xSize = rc.right - rc.left - 17;
				int ySize = rc.bottom - rc.top - 63;

				GetWindowRect(ghDlg, &dlgrc);
				MoveWindow(hWnd, 5, 5, xSize - (dlgrc.right - dlgrc.left), ySize, TRUE);			
			}
            break;
        default:
            return (DefWindowProc(hWnd, msg, wParam, lParam));
    }
    return 0;
}
//------------------------------------------------------------------------------------------
BOOL main_OnCreate(HWND hWnd, LPCREATESTRUCT lpCreateStruct)
{
	InitDialog(hWnd, ghInst);
	return TRUE;
}
//------------------------------------------------------------------------------------------
void main_OnActivate(HWND hWnd, UINT state, HWND hwndActDeact, BOOL fMinimized)
{
	gbActive = (state != WA_INACTIVE && !fMinimized);	
}
//------------------------------------------------------------------------------------------
void main_OnCommand(HWND hWnd, int id, HWND hwndCtl, UINT codeNotify)
{
    switch (id) 
	{
	case IDM_END:
        SendMessage(hWnd, WM_CLOSE, 0, 0);
        break;
	default:
		break;
    }
    return;
}
//------------------------------------------------------------------------------------------
void main_OnClose(HWND hWnd)
{
	DestroyDirectX();
    DestroyWindow(hWnd);
    return;
}
//------------------------------------------------------------------------------------------
void main_OnDestroy(HWND hWnd)
{
    PostQuitMessage(0);
    return;
}
//------------------------------------------------------------------------------------------
LRESULT CALLBACK WndProc (HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	HandleMessages(hWnd, msg, wParam, lParam);

    switch (msg) 
	{
	HANDLE_MSG(hWnd, WM_CREATE, main_OnCreate);
	HANDLE_MSG(hWnd, WM_ACTIVATE, main_OnActivate);
    HANDLE_MSG(hWnd, WM_COMMAND, main_OnCommand);
	HANDLE_MSG(hWnd, WM_CLOSE, main_OnClose);
    HANDLE_MSG(hWnd, WM_DESTROY, main_OnDestroy);   
    default:
       return (DefWindowProc(hWnd, msg, wParam, lParam));
    }
    return 0;
}
//------------------------------------------------------------------------------------------
bool Do_WM_COMMAND (HWND hDlg, WPARAM wParam, LPARAM lParam)
{
	int id = LOWORD(wParam);
	int ievent = HIWORD(wParam); 

    switch (id) 
	{
	case IDC_CHECK_ROTATE_CAMERA:
		{
			HWND hCheckWnd = GetDlgItem(hDlg, IDC_CHECK_ROTATE_CAMERA);
			if(BST_CHECKED == SendMessage(hCheckWnd, BM_GETCHECK , 0 , 0))
				gRotateCamera = true;
			else
				gRotateCamera = false;

            return true;
		}
	}

    return false;
}
//------------------------------------------------------------------------------------------
BOOL OnInitDialog(HWND hWnd, HWND hWndFocus, LPARAM lParam)
{
	ghDlg = hWnd;
	return TRUE;	
}
//------------------------------------------------------------------------------------------
LRESULT CALLBACK DialogProc (HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg) 
	{
	HANDLE_MSG(hDlg, WM_INITDIALOG, OnInitDialog);
    case WM_COMMAND:
		Do_WM_COMMAND(hDlg, wParam, lParam);
		return TRUE;
	default:
		break;
	}
	return FALSE;
}
//------------------------------------------------------------------------------------------
void InitDialog (HWND hWnd, HINSTANCE hInst)
{
	RECT rc;
	int  xSize, ySize;
    
	if (ghDlg)
		   return;
    HWND hDlg = CreateDialog(hInst, "MAINDLG", hWnd, (DLGPROC) DialogProc);

    if(hDlg) 
	{
		ShowWindow(hDlg, SW_SHOW);
        GetWindowRect(hDlg, &rc);
        xSize = rc.right - rc.left + 1;
        ySize = rc.bottom - rc.top + 1;
        GetClientRect(hWnd, &rc);
        MoveWindow(hDlg, rc.right - xSize + 1, rc.top, xSize, rc.bottom, TRUE);	
    } 
}