//**************************************************************//
//  Effect File exported by RenderMonkey 1.6
//
//  - Although many improvements were made to RenderMonkey FX  
//    file export, there are still situations that may cause   
//    compilation problems once the file is exported, such as  
//    occasional naming conflicts for methods, since FX format 
//    does not support any notions of name spaces. You need to 
//    try to create workspaces in such a way as to minimize    
//    potential naming conflicts on export.                    
//    
//  - Note that to minimize resulting name collisions in the FX 
//    file, RenderMonkey will mangle names for passes, shaders  
//    and function names as necessary to reduce name conflicts. 
//**************************************************************//

//--------------------------------------------------------------//
// Light
//--------------------------------------------------------------//
//--------------------------------------------------------------//
// Pass 0
//--------------------------------------------------------------//
string Light_Pass_0_Model : ModelData = ".\\test.x";

struct VS_INPUT
{
   float4 pos : POSITION;
   float3 normal : NORMAL;
};

struct VS_OUTPUT
{
   float4 pos : POSITION;
   float3 diffuse : TEXCOORD1;
   float3 viewDir : TEXCOORD2;
   float3 reflection : TEXCOORD3;
};

float4x4 gWorldMat : World;
float4x4 gViewMat : View;
float4x4 gProjMat : Projection;

float4 gLightPos
<
   string UIName = "gLightPos";
   string UIWidget = "Direction";
   bool UIVisible =  false;
   float4 UIMin = float4( -10.00, -10.00, -10.00, -10.00 );
   float4 UIMax = float4( 10.00, 10.00, 10.00, 10.00 );
   bool Normalize =  false;
> = float4( 500.00, 500.00, -500.00, 1.00 );
float4 gCameraPos
<
   string UIName = "gCameraPos";
   string UIWidget = "Direction";
   bool UIVisible =  false;
   float4 UIMin = float4( -10.00, -10.00, -10.00, -10.00 );
   float4 UIMax = float4( 10.00, 10.00, 10.00, 10.00 );
   bool Normalize =  false;
> = float4( 0.00, 0.00, -200.00, 1.00 );

VS_OUTPUT Light_Pass_0_Vertex_Shader_vs_main(VS_INPUT input)
{
   VS_OUTPUT output;
   
   output.pos = mul(input.pos, gWorldMat);
   
   float3 lightDir = output.pos.xyz - gLightPos.xyz;
   lightDir = normalize(lightDir);
   
   float3 viewDir = output.pos.xyz - gCameraPos.xyz;
   viewDir = normalize(viewDir);
   output.viewDir = viewDir;
   
   output.pos = mul(output.pos, gViewMat);
   output.pos = mul(output.pos, gProjMat);
   
   float3 normal = mul(input.normal, (float3x3)gWorldMat);
   normal = normalize(normal);
   
   //lambert :  max(N*L, 0) 
   output.diffuse = dot(-lightDir, normal);
   output.reflection = reflect(lightDir, normal);
   
   return output;

}
struct PS_INPUT
{
   float3 diffuse : TEXCOORD1;
   float3 viewDir : TEXCOORD2;
   float3 reflection : TEXCOORD3;
};

float4 Light_Pass_0_Pixel_Shader_ps_main(PS_INPUT input) : COLOR
{
   float3 diffuse = saturate(input.diffuse);
   
   float3 reflection = normalize(input.reflection);
   float3 viewDir = normalize(input.viewDir);
   float3 specular = 0;
   if(diffuse.x > 0)
   {
      specular = saturate(dot(reflection, -viewDir));
      specular = pow(specular, 20);
   }
   
   float3 ambient = float3(0.1f, 0.1f, 0.1f);
   
   return float4(ambient + diffuse + specular, 1);
}
//--------------------------------------------------------------//
// Technique Section for Light
//--------------------------------------------------------------//
technique Light
{
   pass Pass_0
   {
      VertexShader = compile vs_2_0 Light_Pass_0_Vertex_Shader_vs_main();
      PixelShader = compile ps_2_0 Light_Pass_0_Pixel_Shader_ps_main();
   }

}

